    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------
    028     * EmptyBlock.java
    029     * ---------------
    030     * (C) Copyright 2004-2007, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 22-Oct-2004 : Version 1 (DG);
    038     * 04-Feb-2005 : Now cloneable and serializable (DG);
    039     * 20-Apr-2005 : Added new draw() method (DG);
    040     *
    041     */
    042
    043    package org.jfree.chart.block;
    044
    045    import java.awt.Graphics2D;
    046    import java.awt.geom.Rectangle2D;
    047    import java.io.Serializable;
    048
    049    import org.jfree.util.PublicCloneable;
    050
    051    /**
    052     * An empty block with a fixed size.
    053     */
    054    public class EmptyBlock extends AbstractBlock
    055                            implements Block, Cloneable, PublicCloneable,
    056                                       Serializable {
    057
    058        /** For serialization. */
    059        private static final long serialVersionUID = -4083197869412648579L;
    060
    061        /**
    062         * Creates a new block with the specified width and height.
    063         *
    064         * @param width  the width.
    065         * @param height  the height.
    066         */
    067        public EmptyBlock(double width, double height) {
    068            setWidth(width);
    069            setHeight(height);
    070        }
    071
    072        /**
    073         * Draws the block.  Since the block is empty, this method does nothing.
    074         *
    075         * @param g2  the graphics device.
    076         * @param area  the area.
    077         */
    078        public void draw(Graphics2D g2, Rectangle2D area) {
    079            // do nothing, we're empty
    080        }
    081
    082        /**
    083         * Draws the block within the specified area.  Since the block is empty,
    084         * this method does nothing.
    085         *
    086         * @param g2  the graphics device.
    087         * @param area  the area.
    088         * @param params  ignored (<code>null</code> permitted).
    089         *
    090         * @return Always <code>null</code>.
    091         */
    092        public Object draw(Graphics2D g2, Rectangle2D area, Object params) {
    093            return null;
    094        }
    095
    096        /**
    097         * Returns a clone of the block.
    098         *
    099         * @return A clone.
    100         *
    101         * @throws CloneNotSupportedException if there is a problem cloning.
    102         */
    103        public Object clone() throws CloneNotSupportedException {
    104            return super.clone();
    105        }
    106
    107    }